/**********************************************************
bisection.cpp

    Description:
    Finding the root of a function f(x) by using bisection
    method.
    
    f(x) = tanh(0.5(x-1)) - 0.1;
    
    Note: Error handling has not been implemented.
***********************************************************/
#include<stdio.h>
#include<math.h>

main()
{
    float ERR; /* Error for stopping criteria */
    float a; /* Step size */
    float x, y, tmp;   /* variable for iteration */
    float fx, fy, ft;
    float precision;
    int k = 0;
    
    printf("Finding the root of tanh(0.5(x-1)) - 0.1.\n");
    printf("Bisection method is applied.\n");
    printf("Enter the initial guess of x (< 0): ");
    scanf("%f", &x);
    printf("Enter the initial guess of y (> 2): ");
    scanf("%f", &y);
    printf("Precision: ");
    scanf("%f", &precision);
    
    /* Bisection Method */
    ERR = y - x;
    fx = tanh(0.5*(x-1)) - 0.1;
    fy = tanh(0.5*(y-1)) - 0.1;
    while((ERR > precision)&&(fx*fy < 0))
    {
    	tmp = (x + y)/2;
    	ft = tanh(0.5*(tmp-1)) - 0.1;
    	if(fx*ft < 0)
		{
			y = tmp;
			fy = ft;
		}
		if(ft*fy < 0)
		{
			x = tmp;
			fx = ft;
		}
    	ERR = y - x;
    	k = k + 1;
    	printf("Step %d: [%0.8f, %0.8f]\n", k, x, y);
    }
        
    /* Output the results on screen */
    printf("The root of f(x) is at %0.8f.\n", x);
}
