/************************************************
poker01.cpp
*************************************************
This program demonstrates how to use rand() and
for-loop to implement card shuffling. Besides,
it demonstrates how to use switch-case to select
the card number output style.

Pseudo code
===========
Step 1: (Card Initialization)
  Initialize CARD[0]=0, CARD[1]=1 and so on.

Step 2: (Card Shuffling)
  Step 2.1: Pick up any two locations tmp1, tmp2.
  Step 2.2: Swap CARD[tmp1] and CARD[tmp2].
  Step 2.3: Allocate CARD[] to PLAYER[][].
  
Step 3: (Output Results)
  For the i-th player, find out the 'hand'
  (i.e. quotient) and 'number' (i.e. remainder)
  of the card number.
      HAND = PLAYER[i][] / 13;
      NUMBER = PLAYER[i][] % 13;
  Use the information 'HAND' to determine
  the output style.

Created on: December 29, 2017.
************************************************/

#include<stdio.h>
#include<stdlib.h>

main()
{
      int MAX = 10000;
      int RANGE = 52;
      int CARD[52];
      int PLAYER[13][4];
      int HAND, NUMBER;
      int i, j;
      int tmp, tmp1, tmp2;
      
      /* Step 1: Card Initialization */
      for(i=0; i<RANGE; i++)
        CARD[i] = i;
      
      /* Step 2: Card shuffling */
      printf("The card are being shuffled now.\n");
      for(i=0; i<MAX; i++)
      {
               tmp1 = rand() % RANGE;
               tmp2 = rand() % RANGE;
               tmp = CARD[tmp1];
               CARD[tmp1] = CARD[tmp2];
               CARD[tmp2] = tmp;       
      }

      for(i=0; i<13; i++)
        for(j=0; j<4; j++)
          PLAYER[i][j] = CARD[i*4+j];
      
      /* Step 3: Output Results */
      printf("Here are the cards.\n");
      for(i=0; i<13; i++)
      {
          printf("Player %2d: ", i+1);
          for(j=0; j<4; j++)
            { 
              tmp = PLAYER[i][j];
              HAND = tmp/13; /* Quotient */
              NUMBER = tmp % 13; /* Remainder */
               
              switch ( HAND )
              {
                     case 0: printf("S%2d   ", NUMBER+1); break;
                     case 1: printf("H%2d   ", NUMBER+1); break;
                     case 2: printf("C%2d   ", NUMBER+1); break;
                     case 3: printf("D%2d   ", NUMBER+1); break;
              }
            }
          printf("\n");  
      }
      
      /* END */
      
}
